/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * 
 */
package org.t2framework.lucy.tx;

import javax.transaction.Transaction;

/**
 * 
 * {@.en Transaction wrapper interface.}
 * 
 * <br />
 * 
 * {@.ja }
 * 
 * @author shot
 * 
 */
public interface TransactionWrapper {

	/**
	 * 
	 * {@.en Begin underlying transaction.}
	 * 
	 * <br />
	 * 
	 * {@.ja }
	 * 
	 * @return
	 * @throws Exception
	 */
	boolean begin() throws Exception;

	/**
	 * 
	 * {@.en Suspend underlying transaction.}
	 * 
	 * <br />
	 * 
	 * {@.ja }
	 * 
	 * @return
	 * @throws Exception
	 */
	Transaction suspend() throws Exception;

	/**
	 * 
	 * {@.en True if there is associated transaction.}
	 * 
	 * <br />
	 * 
	 * {@.ja }
	 * 
	 * @return
	 * @throws Exception
	 */
	boolean hasTransaction() throws Exception;

	/**
	 * 
	 * {@.en Resume underlying transaction.}
	 * 
	 * <br />
	 * 
	 * {@.ja }
	 * 
	 * @param tx
	 * @throws Exception
	 */
	void resume(Transaction tx) throws Exception;

	/**
	 * 
	 * {@.en Set rollback only for associated transaction.}
	 * 
	 * <br />
	 * 
	 * {@.ja }
	 * 
	 */
	void setRollbackOnly();

	/**
	 * 
	 * {@.en Ends underlying transaction.}
	 * 
	 * <br />
	 * 
	 * {@.ja }
	 * 
	 * @throws Exception
	 */
	void end() throws Exception;

}