/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.tx.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import org.t2framework.commons.annotation.Composite;
import org.t2framework.commons.annotation.Lookup;
import org.t2framework.commons.annotation.core.Aspect;
import org.t2framework.lucy.tx.interceptor.NeverInterceptor;

@Retention(RetentionPolicy.RUNTIME)
@Target( { ElementType.TYPE })
@Composite
@Aspect(interceptBy = NeverInterceptor.class)
public @interface NeverTx {

	@Lookup(value = Aspect.class, alias = "pointcut")
	String value() default ".*";
}
